﻿using HeirarchicalGrid.Models;
using Infragistics.Web.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Newtonsoft.Json;

namespace HeirarchicalGrid.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            List<Product> data = new List<Product>();
            List<item> items1 = new List<item>();
            items1.Add(new item() { Id = 1, ItemName = "Bread", Price = 1.4 });
            items1.Add(new item() { Id = 2, ItemName = "Honey", Price = 4.5 });
            data.Add(new Product() { ProductId = 1, Name = "Food", Items = items1 });

            List<item> items2 = new List<item>();
            items2.Add(new item() { Id = 1, ItemName = "Skirt", Price = 32.4 });
            items2.Add(new item() { Id = 2, ItemName = "Hat", Price = 10.3 });
            items2.Add(new item() { Id = 3, ItemName = "Scarf", Price = 10.3 });
            items2.Add(new item() { Id = 3, ItemName = "T-shirt", Price = 10.3 });
            data.Add(new Product() { ProductId = 2, Name = "Clothes", Items = items2 });

            return View(data.AsQueryable());
        }

        [GridDataSourceAction]
        public ActionResult ChangeDataSource1()
        {
            List<Product> data = new List<Product>();
            List<item> items1 = new List<item>();
            items1.Add(new item() { Id = 1, ItemName = "Bread", Price = 1.4 });
            items1.Add(new item() { Id = 2, ItemName = "Honey", Price = 4.5 });
            data.Add(new Product() { ProductId = 1, Name = "Food_NEW " + DateTime.Now.ToString(), Items = items1 });

            List<item> items2 = new List<item>();
            items2.Add(new item() { Id = 1, ItemName = "Skirt", Price = 32.4 });
            items2.Add(new item() { Id = 2, ItemName = "Hat", Price = 10.3 });
            items2.Add(new item() { Id = 3, ItemName = "Scarf", Price = 10.3 });
            items2.Add(new item() { Id = 3, ItemName = "T-shirt", Price = 10.3 });
            data.Add(new Product() { ProductId = 2, Name = "Clothes_NEW " + DateTime.Now.ToString(), Items = items2 });
            List<object> data1 = new List<object>();

            return View(data.AsQueryable());
        }

        [HttpPost]
        public ActionResult SaveDetails()
        {
            string json = HttpContext.Request.Form["gridTransactions"];

            Product[] gridTransactions = JsonConvert.DeserializeObject<Product[]>(json.Replace("],[", ", "));

            GridModel m = new GridModel();

            // Custom code adding the new or editted elements to the database

            return View("Index");
        }
    }
}

